<?php

/** * @description iLM manager
 *  * @authors Patricia Alves Rodrigues, Leônidas O. Brandão
 *  * @version $Id: iln_manager.php$ v 1.0 2012/01/10$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2012/07/02
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */
require_once("../../config.php");
require_once ($CFG->dirroot . '/mod/iassign/lib.php');
require_once ($CFG->dirroot . '/mod/iassign/locallib.php');
require_once ($CFG->dirroot . '/mod/iassign/ilm_manager_form.php');

require_login();
if (isguestuser()) {
    die();
}

//Parameters GET e POST (parâmetros GET e POST)
$id = optional_param('id', 0, PARAM_INT); // Course Module ID
$action = optional_param('action', NULL, PARAM_TEXT);
$from = optional_param('from', NULL, PARAM_TEXT);

$contextuser = get_context_instance(CONTEXT_USER, $USER->id);
$context = get_context_instance(CONTEXT_COURSE, $id);
$url = "$CFG->wwwroot/mod/iassign/ilm_manager.php?from=$from&id=$id";
$course = $DB->get_record('course', array('id' => $id), '*', MUST_EXIST);

$title = get_string('ilm_manager_title', 'iassign');
$PAGE->set_url($url);
$PAGE->set_context($context);

$PAGE->set_course($course);
$PAGE->blocks->show_only_fake_blocks(); //
$PAGE->navbar->add($title);
$PAGE->set_title($course->fullname);


if (has_capability('mod/iassign:editiassign', $context, $USER->id)) {
    $ilm_manager_instance = new ilm_manager($id, $url, $from);
    switch ($action) {
        case 'new':
            $ilm_manager_instance->ilm_editor_new();
            break;
        case 'update':
            $ilm_manager_instance->ilm_editor_update();
            break;
        case 'delete':
            $ilm_manager_instance->delete_file_ilm();
            break;
        case 'duplicate':
            $ilm_manager_instance->duplicate_file_ilm();
            break;
        case 'preview':
            $ilm_manager_instance->preview_ilm();
            break;
        case 'addilm':
            $ilm_manager_instance->add_ilm();
            break;
            die;
    }

    if ($from == 'block')
        $PAGE->set_heading($title);

    if ($from == 'iassign')
        $PAGE->set_pagelayout('popup');

    $mform = new ilm_manager_form();
    $param = new object();
    $param->id = $id; // oculto
    $param->from = $from;
    $mform->set_data($param);

    if ($mform->is_cancelled()) {
        redirect(new moodle_url("/course/view.php?id=$id"));
    } else if ($formdata = $mform->get_data()) {
        $fs = get_file_storage();
        if ($newfilename = $mform->get_new_filename('file')) {

            $filename = $newfilename;

            $files_course = $fs->get_area_files($context->id, 'mod_iassign', 'ilm');

            if ($files_course) {
                foreach ($files_course as $value) {
                    if ($value->get_filename() == $newfilename) {
                        $array_filename = explode('.', $value->get_filename());
                        if (count($array_filename) > 1)
                            $filename = $array_filename[0] . '-' . date("mdy-H:i") . '.' . $array_filename[1];
                        else
                            $filename = $array_filename[0] . '-' . date("mdy-H:i");
                    }
                }
            }

            $file = $mform->save_stored_file('file', $context->id, 'mod_iassign', 'ilm', $formdata->file, '/', $filename, 0, $USER->id);
            $fs->delete_area_files($contextuser->id, 'user', 'draft', $formdata->file);
            $url = "$CFG->wwwroot/mod/iassign/ilm_manager.php?from=$formdata->from&id=$id";
            redirect(new moodle_url($url));
        }
        redirect(new moodle_url($url));
    }

    echo $OUTPUT->header();
    echo $OUTPUT->heading($title);
    $mform->display();
    $ilm_manager_instance->view_files_ilm();
    echo $OUTPUT->footer();
    die;
}
?>