<?php

/** * @description This php script contains all the stuff to interactive Learning Module (iLM)
 *  * @authors Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: config.html$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2013/01/29
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */
defined('MOODLE_INTERNAL') || die;

global $OUTPUT, $CFG, $DB;
require_once($CFG->dirroot . '/mod/iassign/lib.php');
require_once($CFG->dirroot . '/mod/iassign/locallib.php');

$action = optional_param('action', 'view', PARAM_TEXT);
$ilm_id = optional_param('ilm_id', 0, PARAM_INT);
$status = optional_param('status', 0, PARAM_INT);


if ($action == 'visible') {
    ilm_settings::visible_ilm($ilm_id, $status);
    $action = 'view';
}

$str = '';
if ($action == 'view') {

    $url_add = new moodle_url('/mod/iassign/settings_ilm.php', array('action' => 'add'));
    $action_add = new popup_action('click', $url_add, 'popup', array('width' => 900, 'height' => 650));
    $link_add = $OUTPUT->action_link($url_add, get_string('add_ilm_iassign', 'iassign'), $action_add);

    $iassign_ilm = $DB->get_records_sql("SELECT s.*
              FROM {$CFG->prefix}iassign_ilm s
              WHERE s.parent = 0
              ORDER BY `s`.`name` ASC");

    $str.= '<table id="outlinetable" class="generaltable boxaligncenter" cellpadding="5" width="100%">' . chr(13);
    $str .='<tr><td colspan=3 align=right>' . $link_add . '</td></tr>';
    if ($iassign_ilm) {
        foreach ($iassign_ilm as $ilm) {

            if ($ilm->file_jar != $ilm->id) {
                $url_view = new moodle_url('/mod/iassign/settings_ilm.php', array('action' => 'view', 'ilm_id' => $ilm->id));
                $action_view = new popup_action('click', $url_view, 'iplookup', array('title' => get_string('view_ilm', 'iassign'), 'width' => 1200, 'height' => 650));
                $link_view = $OUTPUT->action_link($url_view, icons::insert('view_ilm'), $action_view);
            } else {
                $link_view = '';
            }
            $url_edit = new moodle_url('/mod/iassign/settings_ilm.php', array('action' => 'edit', 'ilm_id' => $ilm->id));
            $action_edit = new popup_action('click', $url_edit, 'iplookup', array('title' => get_string('edit_ilm', 'iassign'), 'width' => 900, 'height' => 650));
            $link_edit = $OUTPUT->action_link($url_edit, icons::insert('edit_ilm'), $action_edit);

            $url = new moodle_url('/admin/settings.php', array('section' => 'modsettingiassign'));
            //$url_visible =$url;
            $url_visible = new moodle_url('/admin/settings.php', array('section' => 'modsettingiassign', 'action' => 'visible', 'ilm_id' => $ilm->id, 'status' => $ilm->enable));

            if ($ilm->enable == 0) {
                $link_visible = $OUTPUT->action_link($url_visible, icons::insert('show_ilm'));
            } elseif ($ilm->enable == 1) {
                $link_visible = $OUTPUT->action_link($url_visible, icons::insert('hide_ilm'));
            } else {
                $link_visible = '&nbsp;' . icons::insert('unlock');
            }

            $iassign_statement = $DB->get_records('iassign_statement', array('iassign_ilmid' => $ilm->id));

            if ($iassign_statement)
                $total = count($iassign_statement);
            else
                $total = 0;

            $str .='<tr>';
            $str.= '<td class="header c1" width=70%><strong>' . $ilm->name . '</strong></td>' . chr(13);
            $str.= '<td class="header c1" width=15% ><strong>' . get_string('activities', 'iassign') . ':</strong>&nbsp;' . $total . '</td>' . chr(13);
            $str.= '<td class="header c1" width=15% align=right valign=bottom>' . $link_edit . '&nbsp;' . $link_visible . '&nbsp;' . $link_view . '</td>' . chr(13);
            $str .='</tr>';

            $str .='<tr><td colspan=3>';
            $str.= '<table width="100%">';

            if (!empty($ilm->url))
                $url_ilm = display_url_ilm($ilm->url);
            else
                $url_ilm = $ilm->url;

            if ($ilm->file_jar == $ilm->id) {
                $ilm->file_jar = "";
            }

            $str .='<tr><td  colspan=3><strong>' . get_string('description', 'iassign') . ':</strong>&nbsp;' . $ilm->description . '</td></tr>';
            $str .='<tr><td  colspan=3><strong>' . get_string('url_ilm', 'iassign') . ':</strong>&nbsp;<a href="' . $url_ilm . '" target="_blank">' . $url_ilm . '</a></td></tr>';
            $str .='<tr><td width="50%"><strong>' . get_string('file_jar', 'iassign') . '</strong>&nbsp;' . $ilm->file_jar . '</td>';
            $str .='<td width="50%"><strong>' . get_string('file_class', 'iassign') . ':</strong>&nbsp;' . $ilm->file_class . '</td></tr>';

            $str .='<tr><td width="50%"><strong>' . get_string('extension', 'iassign') . ':</strong>&nbsp;' . $ilm->extension . '</td>';
            $str .='<td width="50%"><strong>' . get_string('width', 'iassign') . ':</strong>&nbsp;' . $ilm->width;
            $str .='&nbsp;&nbsp;<strong>' . get_string('heigth', 'iassign') . ':</strong>&nbsp;' . $ilm->heigth . '</td></tr>';

            if ($ilm->evaluate == 1)
                $evaluate = get_string('yes', 'iassign');
            else
                $evaluate = get_string('no', 'iassign');

            $str .='<tr><td width="50%"><strong>' . get_string('evaluate', 'iassign') . ':</strong>&nbsp;' . $evaluate . '</td>';

            if ($ilm->enable == 1)
                $enable = get_string('yes', 'iassign');
            else
                $enable = get_string('no', 'iassign');
            $str .='<td width="50%"><strong>' . get_string('enable', 'iassign') . ':</strong>&nbsp;' . $enable . '</td></tr>';

            $str.= '</table>';
            $str .='</td></tr>';
        }
    }
    $str.= '</table>';
}

$settings->add(new admin_setting_heading('iassign', get_string('config_ilm', 'iassign') . $OUTPUT->help_icon('ilm_info', 'iassign'), $str));
?>