<?php

//$$

/** * @description Form to add and edit interactive Learning Module (iLM)
 *  * @authors Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: config_form.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2011/03/31
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */
if (!defined('MOODLE_INTERNAL')) {
    die('Direct access to this script is forbidden.');    ///  It must be included from a Moodle page
}

require_once ($CFG->libdir . '/formslib.php');
require_once ($CFG->dirroot . '/course/moodleform_mod.php');
require_once ($CFG->dirroot . '/mod/iassign/lib.php');

class mod_ilm_form extends moodleform {

    function definition() {
        global $CFG, $COURSE, $USER, $DB;

        $mform = & $this->_form;

        if ($CFG->action_ilm == 'add') {
            $params = array('parent' => '0');
            $tmps = $DB->get_records_sql("SELECT s.id, s.name, s.extension, s.file_jar
                                           FROM {iassign_ilm} s
                                           WHERE s.parent = :parent", $params); // " - jed/emacs
        } else {
            $params = array('id' => $CFG->ilm_id);
            $tmps = $DB->get_records_sql("SELECT s.id, s.name, s.extension, s.file_jar
                                           FROM {iassign_ilm} s
                                           WHERE s.id != :id AND s.parent = 0", $params); // " - jed/emacs
        }
        $extensions = "";
        $names = "";
        $filejars = "";
        foreach ($tmps as $tmp) {
            $extensions .="'" . $tmp->extension . "',";
            $names .="'" . $tmp->name . "',";
            $filejars .="'" . $tmp->file_jar . "',";
        }

        //-----
        ///javascripts 
        $code_javascript = "
             <script type='text/javascript'>
             //<![CDATA[

             function search_name(name){
               var i;
               var names = new Array(";
        $code_javascript .=$names . "'');" . chr(13);
        $code_javascript .="
               for (i=0;i<names.length;i++){
                   if(names[i].toLowerCase()==name.toLowerCase()){
                      document.forms['mform1'].name.value='';
                      confirm('" . get_string('invalid_name_ilm', 'iassign') . " '+names[i]+'!');
                    }
                }";
        $code_javascript .= "}


             function search_extension(extension){
               var i;
               var extensions = new Array(";
        $code_javascript .=$extensions . "'');" . chr(13);
        $code_javascript .="
               for (i=0;i<extensions.length;i++){
                   if(extensions[i].toLowerCase()==extension.toLowerCase()){
                      document.forms['mform1'].extension.value='';
                      confirm('" . get_string('invalid_extension_ilm', 'iassign') . " '+extensions[i]+'!');
                    }
                }";
        $code_javascript .= "}

             function search_filejar(fullfilejar){
               var i;
               var tmp=fullfilejar.split('/');
               var filejar=tmp[tmp.length-1];
                                  
               var filejars = new Array(";
        $code_javascript .=$filejars . "'');" . chr(13);
        $code_javascript .="
               for (i=0;i<filejars.length;i++){
                   if(filejars[i].toLowerCase()==filejar.toLowerCase()){
                      document.forms['mform1'].file_jar[0].value='';
                      confirm('" . get_string('invalid_filejar_ilm', 'iassign') . " '+filejars[i]+'!');
                    }
                }";

        $code_javascript .= "}
               //]]>
               </script>";

        $mform->addElement('html', $code_javascript);

        //-------------------------------------------------------------------------------
        /// Adding the "data_ilm" fieldset, where all the common settings are showed

        $mform->addElement('header', 'data_ilm', get_string('data_ilm', 'iassign'));

        /// Adding the standard "name" field
        $mform->addElement('text', 'name', get_string('name_ilm', 'iassign'), array('size' => '55', 'onchange' => 'search_name(this.value);'));
        $mform->setType('name', PARAM_TEXT);
        $mform->addRule('name', get_string('required', 'iassign'), 'required');

        /// Adding the standard "url" field
        $mform->addElement('text', 'url', get_string('url_ilm', 'iassign'), array('size' => '55'));
        $mform->setType('url', PARAM_TEXT);

        /// Adding the standard "description" field
        $mform->addElement('htmleditor', 'description', get_string('description', 'iassign'));
        $mform->setType('description', PARAM_RAW);
        $mform->addRule('description', get_string('required', 'iassign'), 'required');

        /// Adding the "data_file_jar" fieldset, where all the common settings are showed
        $mform->addElement('header', 'data_file_jar', get_string('data_file_jar', 'iassign'));


        $mform->addElement('static', 'file_jar_static', get_string('file_jar', 'iassign'));

        /// Adding the standard "file_class" field
        $mform->addElement('text', 'file_class', get_string('file_class', 'iassign'), array('size' => '55'));
        $mform->setType('file_class', PARAM_TEXT);
        $mform->addRule('file_class', get_string('required', 'iassign'), 'required');

        /// Adding the standard "extension" field
        $mform->addElement('text', 'extension', get_string('extension', 'iassign'), array('size' => '10', 'onchange' => 'search_extension(this.value);'));
        $mform->setType('extension', PARAM_TEXT);
        $mform->addRule('extension', get_string('required', 'iassign'), 'required');

        /// Adding the standard "width" field
        $mform->addElement('text', 'width', get_string('width', 'iassign'), array('size' => '10'));
        $mform->setType('width', PARAM_TEXT);
        $mform->addRule('width', get_string('required', 'iassign'), 'required');

        /// Adding the standard "heigth" field
        $mform->addElement('text', 'heigth', get_string('heigth', 'iassign'), array('size' => '10'));
        $mform->setType('heigth', PARAM_TEXT);
        $mform->addRule('heigth', get_string('required', 'iassign'), 'required');

        /// Adding the standard "evaluate" field
        $mform->addElement('selectyesno', 'evaluate', get_string('auto_evaluate', 'iassign'));
        $mform->setDefault('evaluate', 1);
        $mform->addRule('evaluate', get_string('required', 'iassign'), 'required');


        /// Upload file ilm

        $mform->addElement('header', 'upload_jar', get_string('upload_ilm', 'iassign'));
        $options = array('subdirs' => 0, 'maxbytes' => $CFG->userquota, 'maxfiles' => -1, 'accepted_types' => '*');
        $mform->addElement('filemanager', 'file', null, null, $options);


        /// Adding the standard "hidden" field
        if ($CFG->action_ilm != 'add')
            $mform->addElement('hidden', 'id');
        $mform->addElement('hidden', 'file_jar');
        $mform->addElement('hidden', 'author');
        $mform->addElement('hidden', 'action');
        $mform->addElement('hidden', 'timecreated');
        $mform->addElement('hidden', 'timemodified');
        $mform->addElement('hidden', 'parent');
        $mform->addElement('hidden', 'enable');

        $this->add_action_buttons();
    }

}
?>


