<?php

/** * @description settings iLM manager
 *  * @authors Patricia Alves Rodrigues, Leônidas O. Brandão
 *  * @version $Id: settings_ilm.php$ v 1.0 2013/01/29$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2013/01/29
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */
global $CFG, $USER, $PAGE, $OUTPUT;

require_once("../../config.php");
require_once ($CFG->dirroot . '/mod/iassign/locallib.php');
require_once ($CFG->dirroot . '/mod/iassign/settings_form.php');


require_login();
if (isguestuser()) {
    die();
}
//Parameters GET e POST (parâmetros GET e POST)
$ilm_id = optional_param('ilm_id', 0, PARAM_INT);
$status = optional_param('status', 0, PARAM_INT);
$action = optional_param('action', NULL, PARAM_TEXT);
$url = new moodle_url('/admin/settings.php', array('section' => 'modsettingiassign'));

$contextuser = get_context_instance(CONTEXT_USER, $USER->id);


$PAGE->set_url($url);
$PAGE->set_context($contextuser);
$PAGE->blocks->show_only_fake_blocks(); //
$PAGE->set_pagelayout('popup');

if ($action == 'edit') {
    $title = get_string('edit_ilm', 'iassign');
    $PAGE->set_title($title);
    $param = ilm_settings::add_edit_ilm($ilm_id, $action);

    $mform = new mod_ilm_form();
    $mform->set_data($param);
    if ($mform->is_cancelled()) {
        close_window();
        die;
    } else if ($formdata = $mform->get_data()) {

        ilm_settings::edit_ilm($formdata);
        close_window(0, true);
        die;
    }

    echo $OUTPUT->header();
    echo $OUTPUT->heading($title);
    $mform->display();
    echo $OUTPUT->footer();
    die;
}

if ($action == 'add') {
    $title = get_string('add_ilm_iassign', 'iassign');
    $PAGE->set_title($title);
    $param = ilm_settings::add_edit_ilm($ilm_id, $action);

    $mform = new mod_ilm_form();
    $mform->set_data($param);
    if ($mform->is_cancelled()) {
        close_window();
        die;
    } else if ($formdata = $mform->get_data()) {
        ilm_settings::new_ilm($formdata);
        close_window(0, true);
        die;
    }
    echo $OUTPUT->header();
    echo $OUTPUT->heading($title);
    $mform->display();
    echo $OUTPUT->footer();
    die;
}


if ($action == 'view') {
    $title = get_string('view_ilm', 'iassign');
    $PAGE->set_title($title);
    $view_ilm = ilm_settings::view_ilm($ilm_id);
    echo $OUTPUT->header();
    echo $OUTPUT->heading($title);
    echo $view_ilm;
    echo $OUTPUT->footer();
    die;
}
?>