<?php

/** * @description Filter iAssign
 *  * @authors Patricia Alves Rodrigues and Leônidas O. Brandão
 *  * @version $Id: filter.php$ v 1.0 2010/09/27$
 *  * @package iAssign: Intective Assignments
 *  * @last modification date 2012/10/10
 *  *
 *  * iMatica - iMath (http://www.matematica.br)
 *  * Computer Science Dep. of IME-USP (Brazil)
 *  * */
defined('MOODLE_INTERNAL') || die();

/**
 * This class looks for email addresses in Moodle text and
 * hides them using the Moodle obfuscate_text function.
 */
class filter_iassign_filter extends moodle_text_filter {

    function filter($text, array $options = array()) {

        global $CFG, $DB, $USER, $COURSE;


        $strs = explode("&lt;/ia&gt;", $text); // < (&lt;) - >(&gt;)
        if (count($strs) > 1) {
            $expressions = array();
            foreach ($strs as $str) {
                $tmp = explode("&lt;ia", $str); // < (&lt;) - / (&frasl;) >(&gt;)
                if (count($tmp) > 1)
                    $expressions[] = trim($tmp[1]);
            } //foreach($strs as $str)

            $text = str_replace("&lt;/ia&gt;", "<br/>", $text);
            $text = str_replace("&lt;ia", "<br/>", $text);

            foreach ($expressions as $expression) {
                // default
                $toolbar = 'disable'; // enable (habilita a barra de botões) disable (desabilita a barra de botões)
                $width = 800;
                $height = 600;

                $tmp = explode("&gt;", $expression); //  >(&gt;)
                $params = trim($tmp[0]);
                $fileid = trim($tmp[1]);

                $params = str_replace("'", "", $params);
                $params = str_replace("&quot;", "", $params);
                $params = explode(" ", $params);

                foreach ($params as $param) {
                    $tmp1 = explode("=", $param);

                    if ($tmp1[0] == "toolbar")
                        $toolbar = $tmp1[1];

                    if ($tmp1[0] == "width")
                        $width = $tmp1[1];

                    if ($tmp1[0] == "height")
                        $height = $tmp1[1];
                } //foreach($params as $param)


                $fs = get_file_storage();
                $file = $fs->get_file_by_id($fileid);
                $ia_content = '';
                $filename = '';
                $output = '';
                if ($file) {
                    $filename = $file->get_filename();
                    $ia_content = $file->get_content();
                    $file_string = utf8_encode($ia_content);
                    $output = $this->convert_applet($filename, $width, $height, $toolbar, $file_string, $fileid);
                } else {
                    $output = "<strong>" . get_string('filenotfound', 'filter_iassign_filter') . "</strong>";
                }

                $text = str_replace($expression, $output, $text);
            } // foreach($expressions as $expression)
        } // if (count($strs)>1)

        return $text;
    }

    function convert_applet($file, $width, $height, $toolbar, $file_string, $fileid) {
        global $CFG, $DB;

        $extension = explode(".", $file);

        $iassign_ilm = $DB->get_record("iassign_ilm", array('extension' => $extension[1], 'parent' => 0));

        $ext = $extension[1];

        $output = '';
        if (empty($iassign_ilm)) {
            $output = "<strong>" . $ext . ": " . get_string('extensionnotfound', 'filter_iassign_filter') . "</strong>";
        } else {

            $lang = substr(current_language(), 0, 2);
            $file_jar = $iassign_ilm->file_jar;
            $file_class = $iassign_ilm->file_class;
            $notSEND = true;

            $enderecoPOST = "";
            $iassignid = 0;

            $token = '';
            $view = -1;
            $end_file = $CFG->wwwroot . DIRECTORY_SEPARATOR . 'mod' . DIRECTORY_SEPARATOR . 'iassign' . DIRECTORY_SEPARATOR . 'ilm_security.php?id=' . $fileid . '&token=' . $token . '&view=' . $view;


            $output .= "
               <applet name='iLM' codebase='../../mod/iassign/ilm/' code='$file_class' archive='$file_jar' width='$width' height='$height' vspace=10 hspace=10>
              ";
            if ($toolbar == "disable")
                $output .="<param name='SOH_ADD' value='ADD'>";
            $output .="
          
           <param name='MA_PARAM_PropositionURL' value='true'/>
           <param name='MA_PARAM_notSEND' value='false'/>
           <param name='lang' value='$lang'/>
           <param name='MA_PARAM_addresPOST' value='$enderecoPOST'> <!-- 2 -->
           <param name='MA_PARAM_Proposition' value='" . $end_file . "'>
           </applet> ";
        }
        return $output;
    }

}

?>
